# tspace-utils

[![NPM version](https://img.shields.io/npm/v/tspace-utils.svg)](https://www.npmjs.com)
[![NPM downloads](https://img.shields.io/npm/dm/tspace-utils.svg)](https://www.npmjs.com)

tspace utils

## Install

Install with [npm](https://www.npmjs.com/):

```sh
npm install tspace-utils --save
```
## Usage

```js
import { Logger } from 'tspace-utils'
/**
 * 
 * 
 * @Logger
*/ 
new Logger().error('message')
new Logger().readLogs()
new Logger().readFolder()

try {
    throw new Error('keeping logs')
} 
catch (err) {
    // new Logger().createLogger(<name folder>).error(err)
    new Logger().error(err)
}
// read data in log file
new Logger().readLogs() // defualt folder log  return array data current date
const path = '<NAME>'
new Logger().readLogs(path)

// read name
new Logger().readFolder() // defult folder log return all files name in folder
const pathFolder = 'log'
new Logger().readFolder(pathFolder)

/**
 * 
 * 
 * @Validate
*/ 
import { Validate , Rules } from 'tspace-utils'

const data = {
    email : 'test@g',
    mobile : '045811xxxx',
    username : 'username',
    password : '',
    passwordConfirm : 'password',
    arrayObject : [
        {
            id : "1",
            name : '',
            email : 'test@g.com',
        },
        {
            id : "xx",
            name : 'qwqw',
            email : 'test',
        },
        {
            id : "",
            name : '',
            email : 'x.com',
        }
    ],
    object: {
        id : "",
        name : '',
        email : 'test@g.com',
        nestObject: {
            test : ""
        }
    }
}

const validate = new Validate(data)

validate.check((rule : Rules) => {   
    return {
        email : new rule().required().email(),
        mobile : new rule().required().number().max(10),
        username : new rule().required().min(3),
        password : new rule().required().confirm('passwordConfirm'),
        passwordConfirm : new rule().required(),
        arrayObject : new rule().arrayObject((rule : Rules) => {
            return {
                id : new rule().required('Email'),
                name : new rule().required().number(),
                email : new rule().required().email()
            }
        }),
        object : new rule().object((rule : Rules) => {
            return {
                id : new rule().required('Email'),
                name : new rule().required(),
                email : new rule().required().email(),
                nestObject : new rule().object((rule : Rules) => {
                    return {
                        id : new rule().required('Email'),
                        name : new rule().required(),
                        email : new rule().required().email(),
                    }
                })
            }
        })
    }      
})

if(validate.fails()) {
    console.log(validate.errorsToString())
    console.log(validate.errors())
    throw ...
}

/**
 * 
 * 
 * @Collection
*/
import { Collection } from 'tsapce-utils'

    const data = [
        {
            id : 3,
            username : 'test3',
            email : null,
            created_at : '2022-06-23 12:30:00',
            updatedAt : '2022-06-23 12:30:00'
        },
        {
            id : 2,
            username : 'test2',
            email : null,
            created_at : '2022-06-21 12:30:00',
            updatedAt : '2022-06-22 12:30:00'
        },
        {
            id : 1,
            username : 'test1',
            email : 'test1@gmail.com',
            created_at : '2022-06-23 15:00:00',
            updatedAt : '2022-06-25 12:30:00'
        },
        {
            id : 5,
            username : 'test5',
            email : 'test5@gmail.com',
            created_at : '2022-06-11 17:00:00',
            updatedAt : '2022-06-22 12:30:00'
        },
        {
            id : 4,
            username : 'test4',
            email : 'test4@gmail.com',
            created_at : '2022-06-22 18:00:00',
            updatedAt : '2022-06-25 18:30:00'
        }
    ]
    
    const map = new Collection(data).map((item: { username: string }) => {
        return { ...item,username : item.username.toUpperCase() }
    }).get()

    const find = new Collection(data).find((item: { id: number }) => item.id === 1).get()

    const each = new Collection(data).each((collect: Collection) => {
        collect.where('id',1).concat([{ id : 10 , username : 'test10' }])
    }).get()
    
    const filter = new Collection(data).filter((item: { id : number }) => item.id === 1).get()

    const reduce = new Collection(data).reduce(( prev:number, cur : { id : number}) => prev + cur.id , 0).get()

    const when = new Collection(data).when(true, (collect: Collection) => {
        collect.map((item: { id : number } , index: number) => item.id * index)
    }).get()

    const whereBetween = new Collection(data).whereBetween('id',[1,2]).get()
    const whereNotBetween = new Collection(data).whereNotBetween('id',[1,2]).get()
    const whereNull = new Collection(data).whereNull('email').get()
    const whereNotNull = new Collection(data).whereNotNull('email').get()
    const where = new Collection(data).where('id',1).where('username','test1').get()
    const whereNotIn = new Collection(data).whereNotIn('id',[1,2,3,4]).get()
    const whereIn = new Collection(data).whereIn('id',[1,2,3,4]).get()
    const count = new Collection(data).count()
    const avg = new Collection(data).avg('id')
    const json = new Collection(data).toJson()
    const sum = new Collection(data).sum('id')
    const max =  new Collection(data).max('id')
    const min = new Collection(data).min('id')
    const chunk = new Collection(data).chunk(3)
    const oldest = new Collection(data).oldest('created_at').get()
    const latest = new Collection(data).latest('created_at').get()
    const limit = new Collection(data).limit(3).get()
    const except = new Collection(data).except('email').get()
    const snakeCase = new Collection(data).snakeCase().get()
    const camelCase = new Collection(data).camelCase().get()

    /* 
        console.log(data ,'data')
        console.log(map,'map')
        console.log(find ,'key')
        console.log(each,'each')
        console.log(filter ,'filter')
        console.log(reduce,'reduce')
        console.log(when ,'when')
        console.log(where ,'where')
        console.log(whereIn ,'whereIn')
        console.log(whereNotIn ,'whereNotIn')
        console.log(whereBetween ,'whereBetween')
        console.log(whereNotBetween ,'whereNotBetween')
        console.log(whereNull ,'whereNull')
        console.log(whereNotNull ,'whereNotNull')
        console.log(count ,'count')
        console.log(json ,'json')
        console.log(avg ,'avg')
        console.log(sum ,'sum')
        console.log(chunk ,'chunk')
        console.log(max ,'max')
        console.log(min ,'min')
        console.log(oldest,'oldest')
        console.log(latest,'latest')
        console.log(limit ,'limit')
        console.log(except ,'except')
        console.log(snakeCase ,'snakeCase')
        console.log(camelCase ,'camelCase')
    */

/**
 * 
 * 
 * @other
*/ 
import {createMap createState , Time} from 'tspace-utils'

const [ state , setState] = createState([])
console.log(state())

setState({
    add : 'state'
})

console.log(state())

console.log(createMap({a : 1 , b: 2 ,c:3}))
console.log(new Time().now())
console.log(new Time().formatDate('yyyy-mm-dd').today())
console.log(new Time().formatDate('yyyy/mm/dd').toDate())
console.log(new Time().minusYears(10).addMonths(1).addDays(10).addHours(2).addMinutes(30).onlyTime().toString())
console.log(new Time().minusYears(10).addMonths(1).minusDays(10).addHours(2).addMinutes(30).onlyDate().toString())
```