"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Collection = void 0;
var Collection = /** @class */ (function () {
    function Collection(data) {
        var _this = this;
        this.ORIGINS = [];
        this.camelCase = function () {
            for (var i = 0; i < _this.ITEMS.length; i++) {
                _this.ITEMS[i] = _this._camelCase(_this.ITEMS[i]);
            }
            return _this;
        };
        this._snakeCase = function (obj) {
            try {
                if (typeof (obj) !== "object")
                    return obj;
                Object.entries(obj).forEach(function (_a) {
                    var _b;
                    var _c = __read(_a, 2), oldName = _c[0], _ = _c[1];
                    var newName = oldName.replace(/([A-Z])/g, function (str) { return "_" + str.toLowerCase(); });
                    if (newName !== oldName) {
                        if (obj.hasOwnProperty(oldName)) {
                            obj = __assign(__assign({}, obj), (_b = {}, _b[newName] = obj[oldName], _b));
                            delete obj[oldName];
                        }
                    }
                    if (typeof (obj[newName]) === "object")
                        obj[newName] = _this._snakeCase(obj[newName]);
                });
                return obj;
            }
            catch (e) {
                return obj;
            }
        };
        this._camelCase = function (obj) {
            try {
                if (typeof (obj) !== "object")
                    return obj;
                Object.entries(obj).forEach(function (_a) {
                    var _b;
                    var _c = __read(_a, 2), oldName = _c[0], _ = _c[1];
                    var newName = oldName.replace(/(.(\_|-|\s)+.)/g, function (str) { return str[0] + (str[str.length - 1].toUpperCase()); });
                    if (newName !== oldName) {
                        if (obj.hasOwnProperty(oldName)) {
                            obj = __assign(__assign({}, obj), (_b = {}, _b[newName] = obj[oldName], _b));
                            delete obj[oldName];
                        }
                    }
                    if (typeof (obj[newName]) === "object")
                        obj[newName] = _this._camelCase(obj[newName]);
                });
                return obj;
            }
            catch (e) {
                return obj;
            }
        };
        if (!Array.isArray(data))
            throw new Error('Collection defined value Array Only');
        this.ITEMS = __spreadArray([], __read(data), false);
        this.ORIGINS = __spreadArray([], __read(data), false);
    }
    Collection.prototype.result = function () {
        return this.ITEMS;
    };
    Collection.prototype.resultAndOrigin = function () {
        return {
            items: this.ITEMS,
            origins: this.ORIGINS
        };
    };
    Collection.prototype.get = function () {
        return this.ITEMS;
    };
    Collection.prototype.first = function () {
        var _a;
        return (_a = this.ITEMS[0]) !== null && _a !== void 0 ? _a : null;
    };
    Collection.prototype.getOrigin = function () {
        return this.ORIGINS;
    };
    Collection.prototype.getAndOrigin = function () {
        return {
            items: this.ITEMS,
            origins: this.ORIGINS
        };
    };
    Collection.prototype.all = function () {
        return this.ITEMS;
    };
    Collection.prototype.shift = function () {
        var _a;
        return (_a = this.ITEMS) === null || _a === void 0 ? void 0 : _a.shift();
    };
    Collection.prototype.pop = function () {
        var _a;
        return (_a = this.ITEMS) === null || _a === void 0 ? void 0 : _a.pop();
    };
    Collection.prototype.isEmpty = function () {
        var _a;
        switch (this._typeOf(this.ITEMS)) {
            case 'Array': {
                return ((_a = this.ITEMS) === null || _a === void 0 ? void 0 : _a.length) ? true : false;
            }
            case 'Object': {
                return Object.keys(this.ITEMS).length ? true : false;
            }
            default: {
                return false;
            }
        }
    };
    Collection.prototype.exists = function () {
        var _a;
        switch (this._typeOf(this.ITEMS)) {
            case 'Array': {
                return ((_a = this.ITEMS) === null || _a === void 0 ? void 0 : _a.length) ? true : false;
            }
            case 'Object': {
                return Object.keys(this.ITEMS).length ? true : false;
            }
            default: {
                return false;
            }
        }
    };
    Collection.prototype.toJson = function () {
        return JSON.stringify(this.ITEMS) || JSON.stringify([]);
    };
    Collection.prototype.count = function () {
        var _a, _b;
        switch (this._typeOf(this.ITEMS)) {
            case 'Array': {
                return (_b = (_a = this.ITEMS) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0;
            }
            case 'Object': {
                return Object.keys(this.ITEMS).length;
            }
            default: {
                return 1;
            }
        }
    };
    Collection.prototype.size = function () {
        var _a, _b;
        switch (this._typeOf(this.ITEMS)) {
            case 'Array': {
                return (_b = (_a = this.ITEMS) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0;
            }
            case 'Object': {
                return Object.keys(this.ITEMS).length;
            }
            default: {
                return 1;
            }
        }
    };
    Collection.prototype.avg = function (key) {
        this._next();
        var avg = this.ITEMS.reduce(function (prev, current) {
            if (key == null)
                return prev + current;
            if (current[key])
                return prev + current[key];
            throw new Error("can't find property [".concat(key, "] in collections"));
        }, 0);
        return avg / this.ITEMS.length;
    };
    Collection.prototype.sum = function (key) {
        this._next();
        var sum = this.ITEMS.reduce(function (prev, current) {
            if (key == null)
                return prev + current;
            if (current[key])
                return prev + current[key];
            throw new Error("can't find property [".concat(key, "] in collections"));
        }, 0);
        return sum;
    };
    Collection.prototype.max = function (key) {
        this._next();
        return Math.max.apply(Math, __spreadArray([], __read(this.ITEMS.map(function (item) {
            if (key == null)
                return item;
            if (item[key])
                return item[key];
            throw new Error("can't find property [".concat(key, "] in collections"));
        })), false));
    };
    Collection.prototype.min = function (key) {
        this._next();
        return Math.min.apply(Math, __spreadArray([], __read(this.ITEMS.map(function (item) {
            if (key == null)
                return item;
            if (item[key])
                return item[key];
            throw new Error("can't find property [".concat(key, "] in collections"));
        })), false));
    };
    Collection.prototype.chunk = function (chunk) {
        if (chunk === void 0) { chunk = 5; }
        this._next();
        return this.ITEMS.reduce(function (chunkArray, item, index) {
            var chunkIndex = Math.floor(index / chunk);
            if (!chunkArray[chunkIndex])
                chunkArray[chunkIndex] = [];
            chunkArray[chunkIndex] = __spreadArray(__spreadArray([], __read(chunkArray[chunkIndex]), false), [
                item
            ], false);
            return chunkArray;
        }, []);
    };
    Collection.prototype.snakeCase = function () {
        for (var i = 0; i < this.ITEMS.length; i++) {
            this.ITEMS[i] = this._snakeCase(this.ITEMS[i]);
        }
        return this;
    };
    Collection.prototype.when = function (value, cb) {
        this._next();
        if (value)
            cb(this);
        return this;
    };
    Collection.prototype.whenEmpty = function (cb) {
        this._next();
        if (!this.ITEMS.length)
            cb(this);
        return this;
    };
    Collection.prototype.whenNotEmpty = function (cb) {
        this._next();
        if (this.ITEMS.length)
            cb(this);
        return this;
    };
    Collection.prototype.where = function (key, operator, value) {
        var _a;
        var _this = this;
        _a = __read(this._valueAndOperator(value, operator, arguments.length === 2), 2), value = _a[0], operator = _a[1];
        this._next();
        this.ITEMS = this.ITEMS.filter(function (item) {
            if (key == null || key === '')
                return _this._operators(operator)(item, value);
            if (!item.hasOwnProperty(key))
                throw new Error("can't find property [".concat(key, "] in collections"));
            var property = item[key];
            var result = _this._operators(operator)(property, value);
            if (result == null)
                throw new Error("not support this operator ".concat(operator));
            return result;
        });
        return this;
    };
    Collection.prototype.whereBetween = function (key, value) {
        this._next();
        if (!Array.isArray(value))
            throw new TypeError("defined value must be an array");
        if (value.length !== 2)
            throw new Error("value must be 2 only");
        var _a = __read(value, 2), v1 = _a[0], v2 = _a[1];
        this.ITEMS = this.ITEMS.filter(function (item) {
            if (key == null || key === '')
                return v1 <= item && item <= v2;
            if (!item.hasOwnProperty(key))
                throw new Error("can't find property [".concat(key, "] in collections"));
            var property = item[key];
            return v1 <= property && property <= v2;
        });
        return this;
    };
    Collection.prototype.whereNotBetween = function (key, value) {
        this._next();
        if (!Array.isArray(value))
            throw new TypeError("defined value must be an array");
        if (value.length !== 2)
            throw new Error("value must be 2 only");
        var _a = __read(value, 2), v1 = _a[0], v2 = _a[1];
        this.ITEMS = this.ITEMS.filter(function (item) {
            if (key == null || key === '')
                return !(v1 <= item && item <= v2);
            if (!item.hasOwnProperty(key))
                throw new Error("can't find property [".concat(key, "] in collections"));
            var property = item[key];
            return !(v1 <= property && property <= v2);
        });
        return this;
    };
    Collection.prototype.whereNull = function (key) {
        this._next();
        this.ITEMS = this.ITEMS.filter(function (item) {
            if (key == null || key === '')
                return item == null;
            if (!item.hasOwnProperty(key))
                throw new Error("can't find property [".concat(key, "] in collections"));
            return item[key] == null;
        });
        return this;
    };
    Collection.prototype.whereNotNull = function (key) {
        this._next();
        this.ITEMS = this.ITEMS.filter(function (item) {
            if (key == null || key === '')
                return item != null;
            if (!item.hasOwnProperty(key))
                throw new Error("can't find property [".concat(key, "] in collections"));
            return item[key] != null;
        });
        return this;
    };
    Collection.prototype.whereIn = function (key, array) {
        this._next();
        this.ITEMS = this.ITEMS.filter(function (item) {
            if (key == null || key === '')
                return array.includes(item);
            if (!item.hasOwnProperty(key))
                throw new Error("can't find property [".concat(key, "] in collections"));
            var property = item[key];
            return array.includes(property);
        });
        return this;
    };
    Collection.prototype.whereNotIn = function (key, array) {
        this._next();
        this.ITEMS = this.ITEMS.filter(function (item) {
            if (key == null || key === '')
                return !array.includes(item);
            if (!item.hasOwnProperty(key))
                throw new Error("can't find property [".concat(key, "] in collections"));
            var property = item[key];
            return !array.includes(property);
        });
        return this;
    };
    Collection.prototype.limit = function (limit) {
        this._next();
        this.ITEMS = this.ITEMS.slice(0, limit);
        return this;
    };
    Collection.prototype.except = function () {
        var _this = this;
        var keys = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            keys[_i] = arguments[_i];
        }
        this._next();
        this.ITEMS = this.ITEMS.map(function (item) {
            keys.forEach(function (key) { return item = __assign({}, _this._removeKey(key, item)); });
            return item;
        });
        return this;
    };
    Collection.prototype.slice = function (start, end) {
        this.ITEMS = this.ITEMS.slice(start, end);
        return this;
    };
    Collection.prototype.forget = function (key) {
        this.ITEMS = this.ITEMS.splice(key, this.ITEMS.length);
        return this;
    };
    Collection.prototype.oldest = function (key) {
        this._next();
        var temp = this._temp();
        temp.sort(function (a, b) {
            if (key == null)
                return a - b;
            if (a[key] && b[key]) {
                var d1 = Date.parse(a[key]);
                var d2 = Date.parse(b[key]);
                if (Number.isNaN(d1) || Number.isNaN(d2))
                    return a[key] - b[key];
                return d1 - d2;
            }
            throw new Error("can't find property [".concat(key, "] in collections"));
        });
        this.ITEMS = temp;
        return this;
    };
    Collection.prototype.latest = function (key) {
        this._next();
        var temp = this._temp();
        temp.sort(function (a, b) {
            if (key == null)
                return b - a;
            if (a[key] && b[key]) {
                var d1 = Date.parse(a[key]);
                var d2 = Date.parse(b[key]);
                if (Number.isNaN(d1) || Number.isNaN(d2))
                    return b[key] - a[key];
                return d2 - d1;
            }
            throw new Error("can't find property [".concat(key, "] in collections"));
        });
        this.ITEMS = temp;
        return this;
    };
    Collection.prototype.push = function (data) {
        this._next();
        this.ITEMS = __spreadArray(__spreadArray([], __read(this.ITEMS), false), [data], false);
        return this;
    };
    Collection.prototype.add = function (data) {
        this._next();
        this.ITEMS = __spreadArray(__spreadArray([], __read(this.ITEMS), false), [data], false);
        return this;
    };
    Collection.prototype.merge = function (data) {
        this._next();
        this.ITEMS = __spreadArray(__spreadArray([], __read(this.ITEMS), false), __read(data), false);
        return this;
    };
    Collection.prototype.each = function (cb) {
        cb(this);
        return this;
    };
    Collection.prototype.findIndex = function (cb) {
        this._next();
        var result = -1;
        for (var i = 0; i < this.ITEMS.length; i++) {
            if (cb(this.ITEMS[i], i) === true) {
                result = i;
                break;
            }
        }
        this.ITEMS = result;
        return this;
    };
    Collection.prototype.every = function (cb) {
        this._next();
        var result = [];
        for (var i = 0; i < this.ITEMS.length; i++) {
            if (cb(this.ITEMS[i], i) === true) {
                result = __spreadArray(__spreadArray([], __read(result), false), [true], false);
                continue;
            }
            result = __spreadArray(__spreadArray([], __read(result), false), [false], false);
        }
        this.ITEMS = true;
        for (var j = 0; j < result.length; j++) {
            if (result[j] === false) {
                this.ITEMS = false;
                break;
            }
        }
        return this;
    };
    Collection.prototype.some = function (cb) {
        this._next();
        var result = false;
        for (var i = 0; i < this.ITEMS.length; i++) {
            if (cb(this.ITEMS[i], i) === true) {
                result = true;
                break;
            }
        }
        this.ITEMS = result;
        return this;
    };
    Collection.prototype.find = function (cb) {
        this._next();
        var result = null;
        for (var i = 0; i < this.ITEMS.length; i++) {
            var collect = this.ITEMS[i];
            if (cb(collect, i) === true) {
                result = collect;
                break;
            }
        }
        this.ITEMS = result;
        return this;
    };
    Collection.prototype.filter = function (cb) {
        this._next();
        var result = [];
        for (var i = 0; i < this.ITEMS.length; i++) {
            var collect = this.ITEMS[i];
            if (cb(collect, i) === true)
                result = __spreadArray(__spreadArray([], __read(result), false), [collect], false);
        }
        this.ITEMS = result;
        return this;
    };
    Collection.prototype.map = function (cb) {
        this._next();
        var result = [];
        for (var i = 0; i < this.ITEMS.length; i++) {
            var collect = this.ITEMS[i];
            result = __spreadArray(__spreadArray([], __read(result), false), [cb(collect, i)], false);
        }
        this.ITEMS = result;
        return this;
    };
    Collection.prototype.reduce = function (cb, result) {
        this._next();
        var i = 0;
        if (arguments.length < 2) {
            result = this.ITEMS[i];
            i = 1;
        }
        for (i; i < this.ITEMS.length; i++) {
            result = cb(result, this.ITEMS[i], i, this.ITEMS);
        }
        this.ITEMS = result;
        return this;
    };
    Collection.prototype._next = function () {
        if (this._typeOf(this.ITEMS) !== 'Array')
            throw new Error('this current value is not an Array');
        return;
    };
    Collection.prototype._temp = function () {
        return this.ITEMS.slice();
    };
    Collection.prototype._removeKey = function (key, _a) {
        var _b = key, _ = _a[_b], rest = __rest(_a, [typeof _b === "symbol" ? _b : _b + ""]);
        return rest;
    };
    Collection.prototype._valueAndOperator = function (value, operator, useDefault) {
        if (useDefault === void 0) { useDefault = false; }
        if (useDefault)
            return [operator, '='];
        if (operator == null)
            throw new Error('bad arguments');
        return [value, operator];
    };
    Collection.prototype._typeOf = function (data) {
        return Object.prototype.toString.apply(data).slice(8, -1);
    };
    Collection.prototype._operators = function (operator) {
        var operators = {
            '=': function (property, value) { return property === value; },
            '<': function (property, value) { return property < value; },
            '>': function (property, value) { return property > value; },
            '<=': function (property, value) { return property <= value; },
            '>=': function (property, value) { return property >= value; },
        };
        return operators[operator];
    };
    return Collection;
}());
exports.Collection = Collection;
exports.default = Collection;
