"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isEmpty = exports.createState = exports.createMap = exports.getType = void 0;
__exportStar(require("./logger"), exports);
__exportStar(require("./validate"), exports);
__exportStar(require("./time"), exports);
__exportStar(require("./collection"), exports);
var getType = function (data) { return Object.prototype.toString.apply(data).slice(8, -1); };
exports.getType = getType;
var createMap = function (data) {
    var map = new Map();
    for (var key in data) {
        var value = data[key];
        map.set(key, value);
    }
    return map;
};
exports.createMap = createMap;
var createState = function (defaultState) {
    if (defaultState === void 0) { defaultState = null; }
    var type = function (data) { return Object.prototype.toString.apply(data).slice(8, -1); };
    var checkType = function (oldState, newState) {
        switch (type(oldState)) {
            case 'Array': {
                oldState = __spreadArray(__spreadArray([], __read(oldState), false), [newState], false);
                break;
            }
            case 'Object': {
                if (type(newState) !== 'Object')
                    throw new TypeError('this state allow object only');
                oldState = __assign(__assign({}, oldState), newState);
                break;
            }
            case 'Boolean': {
                if (type(newState) !== 'Boolean')
                    throw new TypeError('this state allow boolean only');
                oldState = newState;
                break;
            }
            case 'Number': {
                if (type(newState) !== 'Number')
                    throw new TypeError('this state allow number only');
                oldState = newState;
                break;
            }
            case 'String': {
                if (type(newState) !== 'String')
                    throw new TypeError('this state allow string only');
                oldState = newState;
                break;
            }
            case 'Null' || 'Undefined': {
                oldState = newState;
                break;
            }
            default: {
                throw new Error("Can't set state");
            }
        }
        return oldState;
    };
    var getState = function () { return defaultState; };
    var setState = function (newState) { return defaultState = checkType(defaultState, newState); };
    return [getState, setState];
};
exports.createState = createState;
var isEmpty = function (value) {
    var valueIsType = (Object.prototype.toString.apply(value).slice(8, -1)).toLowerCase();
    switch (valueIsType) {
        case 'array': {
            if (!value.length)
                return true;
            break;
        }
        case 'object': {
            if (!Object.keys(value).length)
                return true;
            break;
        }
        case 'boolean': {
            if (!value)
                return true;
            break;
        }
        case 'number': {
            if (value === 0 || Number.isNaN(value))
                return true;
            break;
        }
        case 'string': {
            if (value === '')
                return true;
            break;
        }
        case 'null':
        case 'undefined': {
            if (value == null)
                return true;
            break;
        }
        default: {
            throw new Error("unknown type of value");
        }
    }
    return false;
};
exports.isEmpty = isEmpty;
