"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.Carbon = exports.Time = void 0;
var Time = /** @class */ (function () {
    function Time(dateString) {
        if (dateString === void 0) { dateString = ''; }
        this.DATE = new Date();
        this.FORMAT_DATE = 'yyyy-mm-dd';
        this.FORMAT_TIME = 'h:m:s';
        this.ONLY_TIME = false;
        this.ONLY_DATE = false;
        if (dateString)
            this.DATE = new Date(dateString);
    }
    Time.prototype.parse = function (dateString) {
        return new Date(dateString);
    };
    Time.prototype.addYears = function (year) {
        this.DATE.setFullYear(this.DATE.getFullYear() + year);
        return this;
    };
    Time.prototype.addMonths = function (month) {
        this.DATE.setMonth(this.DATE.getMonth() + month);
        return this;
    };
    Time.prototype.addDays = function (day) {
        this.DATE.setDate(this.DATE.getDate() + day);
        return this;
    };
    Time.prototype.addHours = function (hour) {
        this.DATE.setHours(this.DATE.getHours() + hour);
        return this;
    };
    Time.prototype.addMinutes = function (min) {
        this.DATE.setMinutes(this.DATE.getMinutes() + min);
        return this;
    };
    Time.prototype.addSeconds = function (second) {
        this.DATE.setSeconds(this.DATE.getSeconds() + second);
        return this;
    };
    Time.prototype.minusYears = function (year) {
        this.DATE.setFullYear(this.DATE.getFullYear() - year);
        return this;
    };
    Time.prototype.minusMonths = function (month) {
        this.DATE.setMonth(this.DATE.getMonth() - month);
        return this;
    };
    Time.prototype.minusDays = function (day) {
        this.DATE.setDate(this.DATE.getDate() - day);
        return this;
    };
    Time.prototype.minusHours = function (hour) {
        this.DATE.setHours(this.DATE.getHours() - hour);
        return this;
    };
    Time.prototype.minusMinutes = function (min) {
        this.DATE.setMinutes(this.DATE.getMinutes() - min);
        return this;
    };
    Time.prototype.minusSeconds = function (second) {
        this.DATE.setSeconds(this.DATE.getSeconds() - second);
        return this;
    };
    Time.prototype.startOfDay = function () {
        this.DATE.setHours(0, 0, 0, 0);
        return this;
    };
    Time.prototype.endOfDay = function () {
        this.DATE.setHours(23, 59, 59, 59);
        return this;
    };
    Time.prototype.formatDate = function (formatDate) {
        formatDate = formatDate.toLocaleLowerCase();
        var checkList = formatDate.includes('yyyy')
            && formatDate.includes('mm')
            && formatDate.includes('dd');
        if (!checkList)
            throw new Error('format allow pattern yyyy mm dd');
        this.FORMAT_DATE = checkList ? formatDate : this.FORMAT_DATE;
        return this;
    };
    Time.prototype.formatTime = function (formatTime) {
        formatTime = formatTime.toLocaleLowerCase();
        var checkList = formatTime.includes('h')
            && formatTime.includes('m')
            && formatTime.includes('s');
        if (!checkList)
            throw new Error('format allow pattern h m s');
        this.FORMAT_TIME = checkList ? formatTime : this.FORMAT_TIME;
        return this;
    };
    Time.prototype.onlyTime = function () {
        this.ONLY_TIME = true;
        return this;
    };
    Time.prototype.onlyDate = function () {
        this.ONLY_DATE = true;
        return this;
    };
    Time.prototype.toDate = function () {
        return this.DATE;
    };
    Time.prototype.toTimeStamp = function () {
        return +this.DATE;
    };
    Time.prototype.today = function () {
        return this._dateString(this.DATE);
    };
    Time.prototype.now = function () {
        return "".concat(this._dateString(this.DATE), " ").concat(this._timeString(this.DATE));
    };
    Time.prototype.toString = function (_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.onlyDate, onlyDate = _c === void 0 ? false : _c, _d = _b.onlyTime, onlyTime = _d === void 0 ? false : _d;
        var date = this.DATE;
        var dateString = this._dateString(date);
        if (onlyDate || this.ONLY_DATE)
            return dateString;
        var timeString = this._timeString(date);
        if (onlyTime || this.ONLY_TIME)
            return timeString;
        var now = "".concat(dateString, " ").concat(timeString);
        return now;
    };
    Time.prototype._dateString = function (date) {
        var y = "".concat(date.getFullYear());
        var m = ("0".concat((date.getMonth() + 1))).slice(-2);
        var d = ("0".concat(date.getDate())).slice(-2);
        var format = this.FORMAT_DATE;
        var yyyy = format.replace('yyyy', y);
        var mm = yyyy.replace('mm', m);
        var dateString = mm.replace('dd', d);
        return dateString;
    };
    Time.prototype._timeString = function (date) {
        var h = ("0".concat(date.getHours())).slice(-2);
        var m = ("0".concat(date.getMinutes())).slice(-2);
        var s = ("0".concat(date.getSeconds())).slice(-2);
        var format = this.FORMAT_TIME;
        var hh = format.replace('h', h);
        var mm = hh.replace('m', m);
        var timeString = mm.replace('s', s);
        return timeString;
    };
    return Time;
}());
exports.Time = Time;
var Carbon = /** @class */ (function (_super) {
    __extends(Carbon, _super);
    function Carbon() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return Carbon;
}(Time));
exports.Carbon = Carbon;
