declare class Rule {
    private RULES;
    private MESSAGES;
    private NEST_RULES;
    /**
     * required value. value is not empty
     * @param {string} message  error message
     * @return {this} this
     */
    required(message?: string): this;
    /**
     *
     * @param {string} message  error message
     * @return {this} this
     */
    number(message?: string): this;
    /**
     *
     * @param {string} message  error message
     * @return {this} this
     */
    string(message?: string): this;
    /**
     *
     * @param {string} message  error message
     * @return {this} this
     */
    array(message?: string): this;
    /**
     *
     * @param {string} message  error message
     * @return {this} this
     */
    email(message?: string): this;
    /**
     *
     * @param {string} message  error message
     * @return {this} this
     */
    date(message?: string): this;
    /**
     *
     * @param {string} regexRule regex
     * @param {string} message  error message
     * @return {this} this
     */
    regex(regexRule: string, message?: string): this;
    /**
     *
     * @param {string} key key name for compare
     * @param {string} message  error message
     * @return {this} this
     */
    confirm(key: string, message?: string): this;
    /**
     *
     * @param {number} limit limit characters
     * @param {string} message  error message
     * @return {this} this
     */
    max(limit: number, message?: string): this;
    /**
     *
     * @param {number} limit limit characters
     * @param {string} message  error message
     * @return {this} this
     */
    min(limit: number, message?: string): this;
    /**
     *
     * @param {string} message  error message
     * @return {this} this
     */
    boolean(message?: string): this;
    /**
     * if has 1 arguments. default message = callback
     * @param {string} message
     * @param {function | undefined} cb callback Rule for validate values
     * @return {this} this
     */
    object(message: any, cb?: Function): this;
    /**
     * if has 1 arguments. default message = callback
     * @param {string} message
     * @param {function | undefined} cb callback Rule for validate values
     * @return {this} this
     */
    arrayObject(message: any, cb?: Function): this;
}
export interface Rules {
    new (): Rule;
}
export declare class Validate {
    private ERRORS;
    private REQUESTS;
    constructor(data: object);
    /**
     *
     * check data is correct in the rule validation
     * @param {Rule} callback callback Rule for validation
     * @return {this} this
     */
    check: (callback: Function) => this;
    /**
     *
     * @return {boolean} boolean
     */
    fails: () => boolean;
    /**
     *
     * @return {object} object
     */
    errors: () => object;
    /**
     *
     * @return {string} string
     */
    errorsToString: () => string;
    private _validate;
    private _type;
    private _typeObject;
    private _isEmpty;
    private _errorValidate;
    private _errorValidateObject;
    private _object;
    private _arrayObject;
    private _boolean;
    private _required;
    private _string;
    private _array;
    private _date;
    private _email;
    private _number;
    private _regex;
    private _max;
    private _min;
    private _confirm;
}
export {};
